﻿using UnityEngine;
using System.Collections;

public class CameraManager : MonoBehaviour {

	public float m_positionSmoothTime = 1.0f;
	public GameObject m_target = null;

	private Vector3 m_positionVelocity = Vector3.zero;

	private static CameraManager ms_instance = null;

	public static CameraManager get( ) {
		return ms_instance;
	}

	void Awake( ) {
		ms_instance = this;
	}

	void Start( ) {
		DebugConsole.registerCommand( "lookAt", setTarget );
		DebugConsole.registerCommand( "cameraRotate", rotate );
		DebugConsole.registerCommand( "cameraRotation", rotation );
		transform.GetChild( 0 ).LookAt( transform );
	}

	void Update( ) {
		transform.position = Vector3.SmoothDamp( transform.position, m_target.transform.position, ref m_positionVelocity, m_positionSmoothTime );
	}

	public bool setTarget( string name ) {

		GameObject o = GameObject.Find( name );

		if ( o != null ) {
			m_target = o;
		} else {
			DebugConsole.log( "\"" + name + "\" not found." );			
		}

		return false;
	}

	public void rotate( float degree ) {
		transform.Rotate( new Vector3( 0.0f, degree, 0.0f ) );
	}

	public bool rotate( string s ) {

		float degree = 0.0f;

		if ( float.TryParse( s, out degree ) ) {
			rotate( degree );
		} else {
			DebugConsole.log( "\"" + s + "\" invalid parameter." );
		}

		return false;
	}

	public void rotation( float degree ) {
		transform.rotation = Quaternion.AngleAxis( degree, Vector3.up );
	}

	public bool rotation( string s ) {

		float degree = 0.0f;

		if ( float.TryParse( s, out degree ) ) {
			rotation( degree );
		} else {
			DebugConsole.log( "\"" + s + "\" invalid parameter." );
		}

		return false;
	}
}
